/*	This program is released under GNU General Public License (see COPYING).
 *  It comes AS IS and without any warranty 
 *  (C) 2010 TCM, Open Source Maniax
 */

package gui.dirchooser;

import gui.filetree.FileTree;
import gui.okcancelpanel.OKCancelPanel;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Frame;
import java.nio.file.Path;

import javax.swing.JDialog;

import util.exception.CancelException;

public class DirChooser extends JDialog{
	private static final long serialVersionUID = 1L;
	private OKCancelPanel buttonPanel; 
	private FileTree fileTree;
	
	public static final int OK_OPTION=OKCancelPanel.OK_OPTION;
	public static final int CANCEL_OPTION=OKCancelPanel.CANCEL_OPTION;
	
	public DirChooser(String title,String okCaption,String cancelCaption) {
		super((Frame)null,title,true);
		setSize(360, 360);
		Container contentPane=getContentPane();
		contentPane.setLayout(new BorderLayout());
		buttonPanel=new OKCancelPanel(this, okCaption, cancelCaption);
		fileTree=new FileTree();
		contentPane.add(fileTree,BorderLayout.CENTER);
		contentPane.add(buttonPanel,BorderLayout.SOUTH);
		getRootPane().setDefaultButton(buttonPanel.getOkButton());
	}
	
	public Path getPath() {
		return fileTree.getSelectedDir();
	}
	
	public int showDialog() throws CancelException {
		setVisible(true);
		return buttonPanel.getRetVal();
	}
	
}
