/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package gui.fileselection;

import gui.dirchooser.DirChooser;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.nio.file.Path;

import javax.swing.JButton;

import util.exception.CancelException;

public class PathSelectionButton extends JButton {

	private static final long serialVersionUID = 1L;

	private ActionListener actionListener;
	
	public PathSelectionButton(final PathTextField dest,final String title,final String ok,final String cancel) {
		super("...");
		actionListener=new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				DirChooser dc = new DirChooser(title, ok, cancel);
				try {
					dc.showDialog();
					Path path = dc.getPath();
					if (path != null)
						dest.setPath(path);
					additionalAction();
				} catch (CancelException ce) {
					ce.printStackTrace();
				}
			}
		};
		addActionListener(actionListener);

	}

	protected void additionalAction() {
		
	}
	
	public void invoke(ActionEvent e){
		actionListener.actionPerformed(e);
	}
}
