package gui.settings;

import javax.swing.Action;
import javax.swing.Icon;
import javax.swing.JCheckBox;

import settings.Settings;
import settings.SettingsLoadable;

public class SettingCheckBox extends JCheckBox implements SettingsLoadable {

	private static final long serialVersionUID = 8265388078815700067L;

	private String settingsName;

	private void setSettingsName(String settingsName) {
		this.settingsName = settingsName;
	}

	public SettingCheckBox(Icon icon,String settingsName) {
		super(icon);
		setSettingsName(settingsName);
	}

	public SettingCheckBox(String text,String settingsName) {
		super(text);
		setSettingsName(settingsName);
	}

	public SettingCheckBox(Action a,String settingsName) {
		super(a);
		setSettingsName(settingsName);
	}

	public SettingCheckBox(Icon icon, boolean selected,String settingsName) {
		super(icon, selected);
		setSettingsName(settingsName);
	}

	public SettingCheckBox(String text, boolean selected,String settingsName) {
		super(text, selected);
		setSettingsName(settingsName);
	}

	public SettingCheckBox(String text, Icon icon,String settingsName) {
		super(text, icon);
		setSettingsName(settingsName);
	}

	public SettingCheckBox(String text, Icon icon, boolean selected,String settingsName) {
		super(text, icon, selected);
		setSettingsName(settingsName);
	}

	@Override
	public void loadSettings(Settings s) {
		System.out.println(settingsName);
		setSelected(s.getBoolean(settingsName));
	}

	@Override
	public void saveSettings(Settings s) {
		s.set(settingsName, isSelected());
	}
}
