/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package gui.settings.dialog.component;

import gui.fileselection.PathSelectionButton;
import gui.fileselection.PathTextField;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;

import javax.swing.JLabel;
import javax.swing.JPanel;

import settings.Settings;


public class PathSettingsComponent extends SingleSettingsComponent {

	private JPanel p;
	private PathSelectionButton selButton;
	private PathTextField txtPath;
	
	public PathSettingsComponent(String settingsName, String pathDescr){
		this(settingsName, pathDescr, true);
	}
	
	public PathSettingsComponent(String settingsName, String pathDescr,boolean editable) {
		super(settingsName);
		p=new JPanel();
		JPanel p2=new JPanel();
		p.setLayout(new BorderLayout());
		p2.setLayout(new BorderLayout(20,0));
		txtPath = new PathTextField();
		txtPath.setEditable(editable);
		selButton = new PathSelectionButton(txtPath, "Select path", "OK","Cancel");
		
		if (pathDescr!=null) {
			JLabel l = new JLabel(pathDescr);
			Dimension d=l.getPreferredSize();
			d.setSize(50, d.height);
			l.setPreferredSize(d);
			p2.add(l,BorderLayout.WEST );
		}
		p2.add(txtPath,BorderLayout.CENTER);
		p.add(p2,BorderLayout.CENTER);
		p.add(selButton,BorderLayout.EAST);
	}

	@Override
	public void saveSettings(Settings s) {
		s.set(settingsName, txtPath.getText());
	}

	@Override
	public void loadSettings(Settings s) {
		txtPath.setText(s.getString(settingsName));
	}
	
	@Override
	public Component getComponent() {
		return p;
	}

}
