package gui.settings.dialog.component;

import gui.layout.percent2.APConstraint;
import gui.layout.percent2.AnchorPercentLayout;
import gui.resource.ResourceManager;
import gui.settings.dialog.page.NetworkSettingsPage;

import java.awt.Component;

import javax.swing.JPanel;

import settings.Settings;

public class ProxySettingsComponent extends SettingsComponent {

	private JPanel pProxy=new JPanel();
	private TextSettingsComponent txtHost;
	private UnsignedIntComponent txtPort;
	
	public ProxySettingsComponent(ResourceManager rm) {
		txtHost=new TextSettingsComponent(rm.getLocalizedString(NetworkSettingsPage.LOCALE_PROXY_HOST), NetworkSettingsPage.SETTING_PROXY_HOST){
			@Override
			public void loadSettings(Settings s) {
				 txt.setText(s.getString(settingsName));	
			}
		};
		txtPort=new UnsignedIntComponent(rm.getLocalizedString(NetworkSettingsPage.LOCALE_PROXY_PORT), NetworkSettingsPage.SETTING_PROXY_PORT);
		pProxy.setLayout(new AnchorPercentLayout());
		
		pProxy.add(txtHost.getComponent(),APConstraint.constraint().left(10).top(10).right(10));
		pProxy.add(txtPort.getComponent(),APConstraint.constraint().left(10).bottom(10).right(10));
	}

	@Override
	public void saveSettings(Settings s) {
		txtHost.saveSettings(s);
		txtPort.saveSettings(s);
	}

	@Override
	public void setEnabled(boolean enabled) {
		super.setEnabled(enabled);
		txtHost.setEnabled(enabled);
		txtPort.setEnabled(enabled);
	}
	
	@Override
	public void loadSettings(Settings s) {
		txtHost.setEnabled(s.getBoolean(NetworkSettingsPage.SETTING_PROXY_ENABLED));
		txtHost.loadSettings(s);
		txtPort.loadSettings(s);
	}

	@Override
	public Component getComponent() {
		return pProxy;
	}
	
}