package gui.settings.dialog.component;

import java.awt.LayoutManager;

import gui.util.buttonhandler.ButtonHandler;

import javax.swing.JPanel;
import javax.swing.JRadioButton;

import settings.Settings;

public class RadioButtonSettingsComponent extends SingleSettingsComponent{

	private ButtonHandler handler;
	private JPanel p;
	
	public RadioButtonSettingsComponent(String settingsName) {
		super(settingsName);
		handler=new ButtonHandler();
		p=new JPanel();
	}
	
	public void setLayout(LayoutManager lm) {
		p.setLayout(lm);
	}
	
	public void addRadioButton(JRadioButton rad,Object constraint) {
		handler.add(rad);
		p.add(rad,constraint);
	}

	@Override
	public void saveSettings(Settings s) {
		s.set(settingsName, handler.getSelectedIndex());
	}

	@Override
	public void loadSettings(Settings s) {
		handler.setSelectedButton(s.getInt(settingsName));		
	}

	@Override
	public JPanel getComponent() {
		return p;
	}
	
	public int getSelectedIndex() {
		return handler.getSelectedIndex();
	}
}
