package plugin;

import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLClassLoader;
import java.nio.file.Path;

public class PluginLoader {
	
	public IPlugin load(Path p,String className) {
		try {
			return (IPlugin) new URLClassLoader(new URL[]{p.toUri().toURL()}).loadClass(className).newInstance();
		} catch (InstantiationException | IllegalAccessException | ClassNotFoundException | MalformedURLException e) {
			return null;
		}
	}
}