/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package shoshone.httpclient;

import java.io.IOException;


public class MultipartField extends Multipart {

	private String value;
	
	public MultipartField(Shoshone urlConn,String fieldName,String value) {
		super(urlConn, fieldName);
		
		if (value==null) throw new RuntimeException();
		this.value=value;
		
	}

	@Override
	public void apply() throws IOException {
		urlConn.writeString(PREFIX);										// prefix.length
		urlConn.writeStringAndNewLine(boundary);					// boundary.length + 2
		
		urlConn.writeStringAndNewLine(CONTENT_DISP+fieldName+QUOTE);		// (contentdisp+name+quote).length + 2
		
		urlConn.writeNewline();										// 2
		urlConn.writeStringAndNewLine(value);						// value.length + 2
	}

	@Override
	public long getContentLength() {
		return PREFIX.length()+boundary.length()+(CONTENT_DISP+fieldName+QUOTE).length()+value.length() +8; // 8 -> new lines 
	}

}
