/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package util.base64;

import java.nio.charset.Charset;
import java.util.TreeMap;
import java.util.Map;


public class Base64Encoder {
	private static final Map<Byte,Character> chars;
	private static final Charset UTF8=Charset.forName("UTF-8");
	
	static {
		chars = new TreeMap<>();
		chars.put((byte)0,'A');
		chars.put((byte)1,'B');
		chars.put((byte)2,'C');
		chars.put((byte)3,'D');
		chars.put((byte)4,'E');
		chars.put((byte)5,'F');
		chars.put((byte)6,'G');
		chars.put((byte)7,'H');
		chars.put((byte)8,'I');
		chars.put((byte)9,'J');
		chars.put((byte)10,'K');
		chars.put((byte)11,'L');
		chars.put((byte)12,'M');
		chars.put((byte)13,'N');
		chars.put((byte)14,'O');
		chars.put((byte)15,'P');
		chars.put((byte)16,'Q');
		chars.put((byte)17,'R');
		chars.put((byte)18,'S');
		chars.put((byte)19,'T');
		chars.put((byte)20,'U');
		chars.put((byte)21,'V');
		chars.put((byte)22,'W');
		chars.put((byte)23,'X');
		chars.put((byte)24,'Y');
		chars.put((byte)25,'Z');
		chars.put((byte)26,'a');
		chars.put((byte)27,'b');
		chars.put((byte)28,'c');
		chars.put((byte)29,'d');
		chars.put((byte)30,'e');
		chars.put((byte)31,'f');
		chars.put((byte)32,'g');
		chars.put((byte)33,'h');
		chars.put((byte)34,'i');
		chars.put((byte)35,'j');
		chars.put((byte)36,'k');
		chars.put((byte)37,'l');
		chars.put((byte)38,'m');
		chars.put((byte)39,'n');
		chars.put((byte)40,'o');
		chars.put((byte)41,'p');
		chars.put((byte)42,'q');
		chars.put((byte)43,'r');
		chars.put((byte)44,'s');
		chars.put((byte)45,'t');
		chars.put((byte)46,'u');
		chars.put((byte)47,'v');
		chars.put((byte)48,'w');
		chars.put((byte)49,'x');
		chars.put((byte)50,'y');
		chars.put((byte)51,'z');
		chars.put((byte)52,'0');
		chars.put((byte)53,'1');
		chars.put((byte)54,'2');
		chars.put((byte)55,'3');
		chars.put((byte)56,'4');
		chars.put((byte)57,'5');
		chars.put((byte)58,'6');
		chars.put((byte)59,'7');
		chars.put((byte)60,'8');
		chars.put((byte)61,'9');
		chars.put((byte)62,'+');
		chars.put((byte)63,'/');
	}
	
	
	public static String encode(String s) {
		return encode(s.getBytes(UTF8));
	}
	public static String encode(byte[] b) {
		
		int fill=(3-b.length%3)%3;
		int[] bytes=new int[b.length+fill];
		
		for (int i=0;i<b.length;i++) {
			bytes[i]=b[i]&0xff;
		}
		StringBuilder sb=new StringBuilder(bytes.length*4/3);
		
		
		int i=0;
		while (true) {
			long l=bytes[i];
			l=(l<<8)|bytes[i+1];
			l=(l<<8)|bytes[i+2];
			
			byte b1=(byte)((l&0xfc0000L)>>>18);
			byte b2=(byte)((l&0x3f000L)>>>12);
			byte b3=(byte)((l&0xfc0L)>>>6);
			byte b4=(byte)(l&0x3fL);
						
			sb.append(chars.get(b1));
			if (i++==b.length)
				break;
			
			sb.append(chars.get(b2));
			
			if (i++==b.length)
				break;
			sb.append(chars.get(b3));
			
			if (i++==b.length)
				break;
			sb.append(chars.get(b4));
			if (i==b.length)
				break;
			
		}
		for (i=0;i<fill;i++) {
			sb.append('=');
		}
		return sb.toString();
	}
}
